package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayWorkOrderBaohuoBo;
import com.ruoyi.pay.domain.vo.PayWorkOrderBaohuoVo;
import com.ruoyi.pay.domain.PayWorkOrderBaohuo;
import com.ruoyi.pay.mapper.PayWorkOrderBaohuoMapper;
import com.ruoyi.pay.service.IPayWorkOrderBaohuoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 包活派工单Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayWorkOrderBaohuoServiceImpl implements IPayWorkOrderBaohuoService {

    private final PayWorkOrderBaohuoMapper baseMapper;

    /**
     * 查询包活派工单
     */
    @Override
    public PayWorkOrderBaohuoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询包活派工单列表
     */
    @Override
    public TableDataInfo<PayWorkOrderBaohuoVo> queryPageList(PayWorkOrderBaohuoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayWorkOrderBaohuo> lqw = buildQueryWrapper(bo);
        Page<PayWorkOrderBaohuoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询包活派工单列表
     */
    @Override
    public List<PayWorkOrderBaohuoVo> queryList(PayWorkOrderBaohuoBo bo) {
        LambdaQueryWrapper<PayWorkOrderBaohuo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayWorkOrderBaohuo> buildQueryWrapper(PayWorkOrderBaohuoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayWorkOrderBaohuo> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PayWorkOrderBaohuo::getTenantId, bo.getTenantId());
        lqw.eq(StringUtils.isNotBlank(bo.getArchiveId()), PayWorkOrderBaohuo::getArchiveId, bo.getArchiveId());
        lqw.eq(bo.getProductId() != null, PayWorkOrderBaohuo::getProductId, bo.getProductId());
        lqw.eq(bo.getDeptId() != null, PayWorkOrderBaohuo::getDeptId, bo.getDeptId());
        lqw.eq(StringUtils.isNotBlank(bo.getWorkshop()), PayWorkOrderBaohuo::getWorkshop, bo.getWorkshop());
        lqw.like(StringUtils.isNotBlank(bo.getName()), PayWorkOrderBaohuo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), PayWorkOrderBaohuo::getContent, bo.getContent());
        lqw.eq(bo.getProductNum() != null, PayWorkOrderBaohuo::getProductNum, bo.getProductNum());
        lqw.eq(bo.getPrice() != null, PayWorkOrderBaohuo::getPrice, bo.getPrice());
        lqw.eq(StringUtils.isNotBlank(bo.getUnit()), PayWorkOrderBaohuo::getUnit, bo.getUnit());
        lqw.eq(bo.getAmount() != null, PayWorkOrderBaohuo::getAmount, bo.getAmount());
        lqw.eq(bo.getBeginTime() != null, PayWorkOrderBaohuo::getBeginTime, bo.getBeginTime());
        lqw.eq(bo.getEndTime() != null, PayWorkOrderBaohuo::getEndTime, bo.getEndTime());
        lqw.like(StringUtils.isNotBlank(bo.getQualityName()), PayWorkOrderBaohuo::getQualityName, bo.getQualityName());
        lqw.eq(StringUtils.isNotBlank(bo.getQualityRemark()), PayWorkOrderBaohuo::getQualityRemark, bo.getQualityRemark());
        lqw.eq(bo.getInstorageTime() != null, PayWorkOrderBaohuo::getInstorageTime, bo.getInstorageTime());
        lqw.like(StringUtils.isNotBlank(bo.getInstorageName()), PayWorkOrderBaohuo::getInstorageName, bo.getInstorageName());
        lqw.eq(bo.getInstorageNum() != null, PayWorkOrderBaohuo::getInstorageNum, bo.getInstorageNum());
        lqw.like(StringUtils.isNotBlank(bo.getManagerName()), PayWorkOrderBaohuo::getManagerName, bo.getManagerName());
        lqw.eq(bo.getDeleted() != null, PayWorkOrderBaohuo::getDeleted, bo.getDeleted());
        return lqw;
    }

    /**
     * 新增包活派工单
     */
    @Override
    public Boolean insertByBo(PayWorkOrderBaohuoBo bo) {
        PayWorkOrderBaohuo add = BeanUtil.toBean(bo, PayWorkOrderBaohuo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改包活派工单
     */
    @Override
    public Boolean updateByBo(PayWorkOrderBaohuoBo bo) {
        PayWorkOrderBaohuo update = BeanUtil.toBean(bo, PayWorkOrderBaohuo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayWorkOrderBaohuo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除包活派工单
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
